/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the External Editor extension.
 *
 * The Initial Developer of the Original Code is Philip Nilsson.
 * Portions created by the Initial Developer are Copyright (C) 2005, 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

function ExternalEditorOptions()
{
	this._localeStrings = document.getElementById("bundle_externaleditor_options");
	if (!this._localeStrings) {
		Components.reportError("Could not load locale strings: " + document + ", " + this._localeStrings);
	}

	if (window.arguments && window.arguments[0])
		alert(window.arguments[0]);
}

ExternalEditorOptions.prototype = {
	_localeStrings : null,

	updatePreview : function() {
		var preview = document.getElementById("externaleditor_editor_preview");
		var tempFile = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsILocalFile);
		// XXX: � is replaced with _ for me... fix or not?
		tempFile.appendRelativePath("�" + document.getElementById("extensions.externaleditor.fileext").value);
		tempFile.normalize();
		tempFile = tempFile.path;

		preview.value = document.getElementById("extensions.externaleditor.editor").value;
		args = document.getElementById("extensions.externaleditor.arguments").value;
		sargs = args.replace("%", tempFile);
		preview.value += " " + sargs;
		if (sargs == args) {
			preview.value += " " + tempFile;
		}
	},

	checkFileErrors : function(file, alert) {
		if (!file.exists()) {
			if (alert)
				alert(this._localeStrings.getString("Options_invalid_file"));
			return false;
		}
		if (!file.isExecutable()) {
			if (alert)
				alert(this._localeStrings.getString("Options_not_executable"));
			return false;
		}
		return true;
	},

	checkFilenameErrors : function(filename, alert) {
		var file = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(filename);
		return this.checkFileErrors(file, alert);
	},

	Browse : function() {
		var preference = document.getElementById('extensions.externaleditor.editor');

		var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		var oldFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		try {
			oldFile.initWithPath(preference.value);
			picker.displayDirectory = oldFile;
		} catch (e) {
			// I don't really care.
			// alert(e);
			// return false;
		}
		picker.init(window, this._localeStrings.getString("Options_load_file"), picker.modeOpen);
		picker.appendFilters(picker.filterApps);
		if (picker.show() == picker.returnOK) {
			if (!this.checkFileErrors(picker.file, true)) {
				return false;
			}
			// XXX: Set value instead?
			preference.value = picker.file.path;
			return true;
		}
		return false;
	}
}
